%define desktop_file_utils_version 0.9

Summary: Open source media player based on the Helix framework
Name: HelixPlayer
Version: 1.0.6
Epoch: 1
Release: 1%{?dist}.1
Group: Applications/Multimedia
License: RPSL, EULA
URL: https://player.helixcommunity.org/
Source: hxplay-%{version}.tar.bz2
Source1: buildrc
Obsoletes: G2player, RealOne
ExcludeArch: ppc64 x86_64 s390 s390x ia64
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
Patch2: HelixPlayer-1.0.beta20040615-cvs-no-update.patch
Patch6: HelixPlayer-1.0-ppc-build.patch
Patch7: HelixPlayer-up2date-to-RealPlayer.patch
Patch8: HelixPlayer-1.0.3-exec-shield.patch
Patch9: HelixPlayer-1.0.6-ppc-build.patch
Patch10: HelixPlayer-1.0.6-wallclock.patch
Patch11: HelixPlayer-1.0.6-rtsp-CVE-2009-4247.diff
Patch12: HelixPlayer-1.0.6-smil-CVE-2009-4257.diff
Patch13: HelixPlayer-1.0.6-gif-CVE-2009-424x.diff
Patch14: HelixPlayer-1.0.6-rtsp-CVE-2009-4248.diff
Patch15: HelixPlayer-1.0.6-url-unescape.diff
Patch16: HelixPlayer-1.0.6-rlstate-rulebook.diff

%if %{_lib} == lib64
%define libdepssuffix ()(64bit)
%else
%define libdepssuffix %{nil}
%endif
Requires: libbluecurve.so%{libdepssuffix}
BuildRequires: libtheora-devel >= 1.0alpha3-3
BuildRequires: libvorbis-devel
BuildRequires: gtk2-devel
BuildRequires: python
BuildRequires: prelink
PreReq: desktop-file-utils >= %{desktop_file_utils_version}


%description
The Helix Player 1.0 is an open-source media player built in the Helix 
Community for consumers. Built using GTK, it plays open source formats, 
like Ogg Vorbis and Theora using the powerful Helix DNA Client Media 
Engine.

%prep
%setup -q -n hxplay-%{version}
%patch2 -p1 -b .cvs-no-update
%patch6 -p1 -b .ppc-build
%patch7 -p0 -b .up2date-to-RealPlayer
%patch8 -p1 -b .exec-shield
%patch9 -p1 -b .ppc-build-2
%patch10 -p1 -b .wallclock
%patch11 -p1 -b .rtsp-CVE-2009-4247
%patch12 -p1 -b .smil-CVE-2009-4257
%patch13 -p1 -b .gif-CVE-2009-424x
%patch14 -p1 -b .rtsp-CVE-2009-4248
%patch15 -p1 -b .url-unescape
%patch16 -p1 -b .rlstate-rulebook

%build

BUILDRC=%{SOURCE1} BUILD_ROOT="`pwd`/build" PATH="$PATH:$$BUILD_ROOT/bin" python build/bin/build -t release -k -y %{?_smp_mflags} -m hxplay_gtk_release -p green -P helix-client-all-defines-free player_all 

%install
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
cat > $RPM_BUILD_ROOT/%{_bindir}/hxplay <<EOF
#!/bin/sh
HELIX_LIBS=%{_libdir}/helix
export HELIX_LIBS
exec %{_bindir}/hxplay.bin "\$@"
EOF
cp release/hxplay.bin $RPM_BUILD_ROOT/%{_bindir}
chmod a+x $RPM_BUILD_ROOT/%{_bindir}/*
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/helix/common
cp player/installer/archive/temp/common/*.so $RPM_BUILD_ROOT/%{_libdir}/helix/common
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/helix/plugins
cp player/installer/archive/temp/plugins/*.so $RPM_BUILD_ROOT/%{_libdir}/helix/plugins

mkdir -p $RPM_BUILD_ROOT/%{_libdir}/helix
cp player/installer/archive/temp/LICENSE $RPM_BUILD_ROOT/%{_libdir}/helix
cp player/installer/archive/temp/README $RPM_BUILD_ROOT/%{_libdir}/helix
(cd $RPM_BUILD_ROOT/%{_docdir}/%{name}-%{version} && ln -s %{_libdir/helix} .)

mkdir -p $RPM_BUILD_ROOT/%{_libdir}/helix/codecs
cp player/installer/archive/temp/codecs/*.so $RPM_BUILD_ROOT/%{_libdir}/helix/codecs
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/mozilla/plugins
cp player/installer/archive/temp/mozilla/nphelix.so $RPM_BUILD_ROOT/%{_libdir}/mozilla/plugins
cp player/installer/archive/temp/mozilla/nphelix.xpt $RPM_BUILD_ROOT/%{_libdir}/mozilla/plugins
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/application-registry/
cp player/installer/common/hxplay.applications $RPM_BUILD_ROOT/%{_datadir}/application-registry/
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/applications/
cp player/installer/common/hxplay.desktop $RPM_BUILD_ROOT/%{_datadir}/applications/realplay.desktop
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/mime-info/
cp player/installer/common/hxplay.keys $RPM_BUILD_ROOT/%{_datadir}/mime-info
cp player/installer/common/hxplay.mime $RPM_BUILD_ROOT/%{_datadir}/mime-info

mkdir -p $RPM_BUILD_ROOT/%{_datadir}/pixmaps/
cp player/app/gtk/res/hxplay.png $RPM_BUILD_ROOT/%{_datadir}/pixmaps

mkdir -p $RPM_BUILD_ROOT/%{_libdir}/helix/share/hxplay
(cd $RPM_BUILD_ROOT/%{_libdir}/helix/share/ && ln -s %{_datadir}/pixmaps/hxplay.png .)
cp player/app/gtk/res/default/*.png $RPM_BUILD_ROOT/%{_libdir}/helix/share/hxplay
cp player/app/gtk/res/hxplay/*.png $RPM_BUILD_ROOT/%{_libdir}/helix/share/hxplay
for LANGUAGE in "de" "es" "fr" "it" "ja" "ko" "pt_BR" "zh_CN" "zh_TW"; do
	dir=$RPM_BUILD_ROOT/%{_datadir}/locale/$LANGUAGE/LC_MESSAGES/
	mkdir -p $dir
	cp "player/installer/archive/temp/share/locale/$LANGUAGE/player.mo" "$dir/hxplay.mo"
	cp "player/installer/archive/temp/share/locale/$LANGUAGE/widget.mo" "$dir/libgtkhx.mo"
done

for SIZE in "16x16" "32x32" "48x48" "128x128" "192x192" ; do
    mkdir -p $RPM_BUILD_ROOT/%{_datadir}/icons/hicolor/$SIZE
    mkdir -p $RPM_BUILD_ROOT/%{_datadir}/icons/hicolor/$SIZE/apps
    mkdir -p $RPM_BUILD_ROOT/%{_datadir}/icons/hicolor/$SIZE/mimetypes
    
    ICON=player/app/gtk/res/icons/hxplay/hxplay_${SIZE}.png
    if [ -f "$ICON" ] ; then
	mkdir -p $RPM_BUILD_ROOT/%{_datadir}/icons/hicolor/${SIZE}/apps
        cp "$ICON" $RPM_BUILD_ROOT/%{_datadir}/icons/hicolor/${SIZE}/apps/hxplay.png
    fi

    for MIME in \
        "application-ram"     \
        "application-rpm"     \
        "application-rm"      \
        "audio-ra"            \
        "video-rv" ; do
      ICON=player/app/gtk/res/icons/hxplay/mime-${MIME}_${SIZE}.png
      if [ -f "$ICON" ] ; then
	  mkdir -p $RPM_BUILD_ROOT/%{_datadir}/icons/hicolor/${SIZE}/mimetypes
          cp "$ICON" $RPM_BUILD_ROOT/%{_datadir}/icons/hicolor/${SIZE}/mimetypes/hxplay-${MIME}.png
      fi
    done
done

# Hack to get rid of executable stack on shared object files
execstack -c $RPM_BUILD_ROOT/%{_libdir}/helix/codecs/colorcvt.so
execstack -c $RPM_BUILD_ROOT/%{_libdir}/helix/codecs/cvt1.so
execstack -c $RPM_BUILD_ROOT/%{_libdir}/helix/plugins/vidsite.so

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-desktop-database %{_datadir}/applications

%postun
update-desktop-database %{_datadir}/applications

%files
%defattr(-,root,root)
%{_bindir}/hxplay*
%{_libdir}/helix/*
%{_libdir}/mozilla/*
%{_datadir}/icons/hicolor/*
%{_datadir}/mime-info/*
%{_datadir}/pixmaps/*
%{_datadir}/locale/de/*
%{_datadir}/locale/es/*
%{_datadir}/locale/fr/*
%{_datadir}/locale/it/*
%{_datadir}/locale/ja/*
%{_datadir}/locale/ko/*
%{_datadir}/locale/pt_BR/*
%{_datadir}/locale/zh_CN/*
%{_datadir}/locale/zh_TW/*
%{_datadir}/applications/realplay.desktop
%{_datadir}/application-registry/hxplay.applications

%changelog
* Thu Feb  4 2010 Tomas Hoger <thoger@redhat.com> 1.0.6-1.1
- Multiple security fixes:
  http://service.real.com/realplayer/security/01192010_player/en/

* Tue Jun 26 2007 Josh Bressers <bressers@redhat.com> 1:1.0.6-0.EL4.2.0.2
- Rebuild for z-stream bz#245842

* Tue Jun 26 2007 Chris Aillon <caillon@redhat.com> 1:1.0.6-0.EL4.2
- Add a fix for CVE-2007-3410

* Tue Sep 20 2005 John (J5) Palmieri <johnp@redhat.com> 1:1.0.6-0.EL4.1
- Update to 1.0.6
- Add patch to fix ppc build problems

* Fri Jun 10 2005 John (J5) Palmieri <johnp@redhat.com> 1:1.0.5-0.EL4.1
- Update to 1.0.5 as fix for bug #159872

* Tue Apr 19 2005 John (J5) Palmieri <johnp@redhat.com> 1:1.0.4-1.1.EL4.2
- Add execshield fix

* Tue Apr 19 2005 John (J5) Palmieri <johnp@redhat.com> 1:1.0.4-1.1.EL4.1
- Bump release to not conflict with FC4

* Tue Apr 19 2005 John (J5) Palmieri <johnp@redhat.com> 1:1.0.4-1.1
- Bump release and rebuild

* Tue Apr 19 2005 John (J5) Palmieri <johnp@redhat.com> 1:1.0.4-1
- Update to upstream version 1.0.4 to fix security vulnerability (155386)

* Wed Mar  2 2005 Ray Strode <rstrode@redhat.com> 1:1.0.3-2
- Attempt to address execshield regressions.

* Wed Mar  2 2005 Ray Strode <rstrode@redhat.com> 1:1.0.3-1
- Update to 1.0.3 fixes for 150098 and 150103. 

* Thu Oct 28 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-8EL
- RHEL rebuild

* Mon Oct 25 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-7
- Add patch from Real to up2date to RealPlayer instead of
  going to the Real website.

* Fri Oct 15 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-6
- Require libbluecurve.so to fix 135709, since it apparently
  cannot be done in comps at this point.

* Fri Oct 15 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-5
- Ok, we can not Requires: redhat-artwork.i386.  Reassigning
  135709 to comps.

* Thu Oct 14 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-4
- Pull in 32-bit redhat-artwork on x86_64 (135709)
- Rename hxplay.desktop to realplay.desktop, in order to set 
  default mime handlers for realplay.desktop, until we get
  multiple application support in defaults.list (135705)

* Wed Oct 13 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-3
- Install translations (bug 132336)

* Thu Oct 07 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-2
- Fix wrapper script to handle commandline arguments

* Sun Oct 03 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-1
- Update to 1.0.1
- Add epoch since 1.0.1.gold is older than 1.0.gold
- Drop upstreamed HelixPlayer-1.0.beta20040615-mmx-clobber.patch
- Drop HelixPlayer-1.0.beta20040615-desktop.patch per request
- Drop upstreamed HelixPlayer-1.0-filechooser.patch
- Drop upstreamed HelixPlayer-1.0-clobberedx.patch
- Switch to bingo-gold target

* Thu Sep 30 2004 Christopher Aillon <caillon@redhat.com> 1.0.gold-6
- PreReq desktop-file-utils >= 0.9

* Tue Sep 21 2004 David Woodhouse <dwmw2@redhat.com> 1.0.gold-5
- Build on PPC

* Tue Sep 14 2004 Colin Walters <walters@redhat.com> 1.0.gold-4
- Add patch from Real to fix math64.h compilation
- Invoke update-desktop-database in post and postun, in
  preparation for fixing .desktop file for mime system
- Address some issues from #130744, thanks Ling Li:
  - Do release build
  - Install release binary
  - Fix typo in png installation
- Remove hack for installing debug ogg format

* Mon Aug 23 2004 Colin Walters <walters@redhat.com> 1.0.gold-3
- Install README and LICENSE

* Fri Aug 06 2004 Colin Walters <walters@redhat.com> 1.0.gold-2
- Put mozilla plugins in correct directory (#129305)

* Mon Aug 02 2004 Colin Walters <walters@redhat.com> 1.0.gold-1
- Update to gold
- Use setup -n to set directory instead of repacking tarball
- Switch bif target to bingo-gold-free

* Thu Jul 29 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-6
- Rework Summary a bit
- Minor spec cleanups

* Mon Jul 26 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-5
- Add patch to port to GtkFileChooser
- ExcludeArch ppc

* Fri Jul 16 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-4
- Restore MIME icon installation into hicolor directory 

* Fri Jul 16 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-3
- Add patch to fix desktop file name
- Set build failure color to "green" to exit on any error
- Add smp_mflags variable for parallel building

* Thu Jul 15 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-2
- BR latest theora
- More spec file bits
- Install logo for real

* Mon Jul 12 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-1
- Some spec file cleanups

* Mon Jun 8 2004 Ryan Gammon <rgammon@real.com>
- Adding /usr/share/pixmap, document icons

* Mon Jun 7 2004 Nicholas Hart <nhart@real.com>
- added .mime/.keys/.applications files

* Wed May 5 2004 Ryan Gammon <rggammon@helixcommunity.org>
- Updating icons

* Thu Jan 13 2004  Nicholas Hart <nhart@helixcommunity.org>
- tweaked some paths to deal with tarball generated by player/installer/app
- changed, reformatted some of the package info

* Sat Dec 27 2003 Thomas Chung <tchung@linuxinstall.org> 0.2.0.0-20031224
- First RPM build for Fedora Core 1
